var timeout,
	timeout_loading, 
	hoje = new Date().toISOString().slice(0,10),
	db_key, 
	db_func, 
	db_jogo_id, 
	app_in_background = false, 
	alfabeto = 'abcdefghijklmnopqrstuvwxyz',
	transaction;

// < Cache
var cache_diario = getCache('cache_diario');
if (!cache_diario || cache_diario != hoje) {
	remCache('animacoes');
	remCache(null, '/futebol/jogos/');
	setCache('cache_diario', hoje);
}

var jogos = getCache('jogos', true);
var keys = Object.keys(jogos);
if (keys.length > 50) {
	remCache('jogos');
	remCache(null, 'jogo_');
}
// > Cache END

var configFirebase = {
	apiKey : 'AIzaSyC9Hx4nxPBFnh_N6C7DdM_C2dg8G9h6Z_8',
	databaseURL : 'https://licoski-d8cbd.firebaseio.com/',
	storageBucket : 'licoski-d8cbd.appspot.com'
};
firebase.initializeApp(configFirebase);

angular.module('starter', ['ionic', 'starter.controllers'])

.directive('imgLoad', function() {
	return {
		link: function (scope, element, attrs) {
			element.bind("load" , function(e) { 
				element.css("background-image", "none");
			});
			if (attrs.class.indexOf('jogador') >= 0) {
				element.bind("error" , function(e) { 
					element.attr("src", 'img/jogador.png');
				});
			}
			else if (attrs.class.indexOf('logo') >= 0) {
				element.bind("error" , function(e) { 
					element.attr("src", 'img/default.png');
				});
			}
		}
	}
})
.directive('frameLoad', function($ionicLoading) {
	return {
		link: function (scope, element, attrs) {
			element.bind("load" , function(e) { 
				$ionicLoading.hide();
			});
		}
	}
})
.directive("animationGol", function($timeout) {

    return {
		link : function(scope, element, attrs) {
			
			var timer = $timeout(function() {
				element.remove();
			}, 5000);
			
		}
    }

})

.constant("appConfig", {"id":"gauchao.licoski.com","token":"QTZTv4Ut2Ha9xGC3","version":20,"email":"gauchao@licoski.com"})

.constant('$ionicLoadingConfig', {
	template : '<ion-spinner icon="android"></ion-spinner>',
	noBackdrop : true
})

.run(function($rootScope, $http, $state, $ionicPlatform, $ionicPopup, $ionicLoading, $ionicHistory, appConfig) {

	var escudo = appConfig.id.replace('.licoski.com', '');

	$rootScope.config = getCache("configs_user", true);
	if ($rootScope.config['horario_verao'] === undefined) {
		$rootScope.config['horario_verao'] = false;
	}
	if ($rootScope.config['notification'] === undefined) {
		$rootScope.config['notification'] = true;
	}
	if ($rootScope.config['news'] === undefined) {
		$rootScope.config['news'] = true;
	}
	if ($rootScope.config['sound'] === undefined) {
		$rootScope.config['sound'] = true;
	}
	if ($rootScope.config['idioma'] === undefined) {
		var idioma = navigator.language || navigator.userLanguage;
		if (idioma.length) {
			idioma = idioma.substr(0,2);
			if (idioma != 'pt' && idioma != 'en' && idioma != 'es') {
				idioma = 'en';
			}
			$rootScope.config['idioma'] = idioma;
		}
	}
	setCache("configs_user", $rootScope.config);
	
	$rootScope.db_keys = {}; // keys iniciadas realtime
	$rootScope.db_jogo = {};
	$rootScope.db_jogos = {};
	
	$rootScope.campeonato = 'equipe';
	
	$rootScope.text = {};
	
	$rootScope.dados = {};
	$rootScope.dados['primeira_vez'] = getCache('primeira_vez') === null ? true : false;
	$rootScope.dados['watch_count'] = 0;
	$rootScope.dados['menu'] = 'jogos_do_time';
	$rootScope.dados['ranking_tipo'] = '5'; // campeonato_id
	$rootScope.dados['timezone'] = new Date().toString().match(/([-\+][0-9]+)\s/)[1];
	$rootScope.dados['noticias_lidas'] = getCache('noticias_lidas', true);
	$rootScope.dados['expandir'] = getCache('expandir', false, false);
	
	if (!$rootScope.dados['timezone']) {
		$rootScope.dados['timezone'] = '-0300';
	}
	if ($rootScope.config['horario_verao']) {
		$rootScope.dados['timezone'] = '-0'+ (parseInt(somenteNumeros($rootScope.dados['timezone']))+100);
	}
	
	$rootScope.fases = {};
	$rootScope.fase = {};
	$rootScope.titulo = {};
	
	$rootScope.votos = getCache('votos', true);
	$rootScope.notificar = getCache('notificar', true);
	
	// $rootScope.equipes = getCache("equipes");
	// $rootScope.equipes_filtravel = $rootScope.equipes;
	$rootScope.equipe = getCache('equipe', true);
	if ($rootScope.equipe.equipe_img == undefined) {
		$rootScope.equipe.equipe_img = 'img/logo.png';
	}

	$rootScope.server_url = (window.location.href.indexOf('andrelicoski') < 0) ? "http://licoski.com/futebol-server/" : 'http://localhost/andrelicoski/futebol-server/';
	$rootScope.debug = (window.location.href.indexOf('andrelicoski') < 0) ? false : true;
	$rootScope.loading_count = 1;
	
	setCache('primeira_vez', false);
	
	$ionicPlatform.ready(function() {
	  
		if (window.cordova) {
			
			if (window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(true);
			}
			
		}
		
		if (window.StatusBar) {
			if (ionic.Platform.isAndroid()) {
				StatusBar.backgroundColorByHexString("#444444");
			} 
			else {
				StatusBar.styleLightContent();
			}
		}
		
		if (window.plugins) {
			
			if (window.plugins.AdMob) {
				
				window.plugins.AdMob.setOptions( {
					publisherId: 'ca-app-pub-3776894028043661/9651127232',
					interstitialAdId: 'ca-app-pub-3776894028043661/2127860430',
					bannerAtTop: false, // set to true, to put banner at top
					overlap: false, // set to true, to allow banner overlap webview
					offsetTopBar: false, // set to true to avoid ios7 status bar overlap
					isTesting: false, // receiving test ad
					autoShow: true // auto show interstitial ad when loaded
				});
				
				if (!($rootScope.config['remove_ads'])) {
					window.plugins.AdMob.createBannerView();
				}
				
			}
			
		}
		
		// Pega dados do JSON e em caso de erro consulta o Firebase
		$rootScope.getDados = function(url_json, url_firebase, callback) {
			
			$http.get($rootScope.server_url + url_json, { 
				params : {
					token : appConfig.token,
					app_id : appConfig.id
				},
				timeout: 45000
			}).success(function(response) {
				
				if (response && response != 'Could not connect to database.') {
					
					callback(response);
					
					if ($rootScope.debug) {
						console.log('JSON OK!');
					}
					
				}
				else {

					if (url_firebase) {
					
						if ($rootScope.db_keys[url_firebase] == undefined) {
						
							$rootScope.db_keys[url_firebase] = true;
							var db = firebase.database().ref(url_firebase);
							db.on('value', function(dados) {

								callback(dados.val(), dados.ref.key);
								
								if ($rootScope.debug) {
									console.log('Firebase OK on EMPTY JSON!');
								}
							
							}, function(error) {
								alert('Unavailable server.');
							});
							
						}
						
					}
					else if ($rootScope.debug) {
						console.log('Firebase URL not set!');
					}
				
				}
				
			}).error(function() {
			
				if (url_firebase) {
			
					if ($rootScope.db_keys[url_firebase] == undefined) {
					
						$rootScope.db_keys[url_firebase] = true;
						var db = firebase.database().ref(url_firebase);
						db.on('value', function(dados) {

							callback(dados.val(), dados.ref.key);
							
							if ($rootScope.debug) {
								console.log('Firebase OK on ERROR JSON!');
							}
						
						}, function(error) {
							alert('Unavailable server.');
						});
						
					}
				
				}
				else if ($rootScope.debug) {
					console.log('Firebase URL not set!');
				}
			
			});
			
		};
		
		// < Equipes
		$rootScope.getEquipeByID = function(equipe_id, equipes) {
			
			if ($rootScope.dados['getEquipeByID'] == undefined) {
				$rootScope.dados['getEquipeByID'] = {};
			}
			if ($rootScope.dados['getEquipeByID'][equipe_id] != undefined) {
				return $rootScope.dados['getEquipeByID'][equipe_id];
			}
			
			var escudo_default = $rootScope.config['escudo_default'];
			if (escudo_default === undefined) {
				escudo_default = true;
			}
			
			if (equipes == undefined) {
				equipes = $rootScope.equipes;
			}
			if (equipes == undefined) {
				return undefined;
			}
			
			var equipes_keys = Object.keys(equipes);
			for (var x=0;x < equipes_keys.length;x++) {
				
				var i = equipes_keys[x];
				if (equipes[i].equipe_id == equipe_id) {
					
					if (escudo_default) {
						equipes[i].img = 'img/default.png';
					}
					$rootScope.dados['getEquipeByID'][equipe_id] = equipes[i];
					return equipes[i];
					
				}
				
			}

			return undefined;
			
		};
		$rootScope.setEquipesDados = function(equipes) {
			
			if (equipes == null) {
				return equipes;
			}
			
			if (equipes.campeonato_id != undefined) {
				equipes.campeonato = $rootScope.getNomeCampeonatoById(equipes.campeonato_id);
			}
			
			if (equipes.equipe_id != undefined) {
				
				var equipe = $rootScope.getEquipeByID(equipes.equipe_id);
				if (equipe != undefined) {
					equipes.nome = equipe.nome;
					equipes.sigla = equipe.sigla;
					equipes.equipe_img = equipe.img;
				}
				
				// equipes.equipe_img = $rootScope.getEquipeImg(equipes.equipe_id);
			
			}
			else if (equipes.equipe_id_1 != undefined) {
				
				var equipe_1 = $rootScope.getEquipeByID(equipes.equipe_id_1);
				if (equipe_1 != undefined) {
					equipes.equipe_nome_1 = equipe_1.nome;
					equipes.equipe_sigla_1 = equipe_1.sigla;
					equipes.equipe_img_1 = equipe_1.img;
				}
				
				// equipes.equipe_img_1 = $rootScope.getEquipeImg(equipes.equipe_id_1);
				
				var equipe_2 = $rootScope.getEquipeByID(equipes.equipe_id_2);
				if (equipe_2 != undefined) {
					equipes.equipe_nome_2 = equipe_2.nome;
					equipes.equipe_sigla_2 = equipe_2.sigla;
					equipes.equipe_img_2 = equipe_2.img;
				}
				
				// equipes.equipe_img_2 = $rootScope.getEquipeImg(equipes.equipe_id_2);
			
			}
			else {
				
				var equipes_keys = Object.keys(equipes);
				for (var x=0;x < equipes_keys.length;x++) {
					
					var i = equipes_keys[x];
					
					if (equipes[i].campeonato_id != undefined) {
						equipes[i].campeonato = $rootScope.getNomeCampeonatoById(equipes[i].campeonato_id);
					}
					
					if (equipes[i].equipe_id != undefined) {
						
						var equipe = $rootScope.getEquipeByID(equipes[i].equipe_id);
						if (equipe != undefined) {
							equipes[i].nome = equipe.nome;
							equipes[i].sigla = equipe.sigla;
							equipes[i].equipe_img = equipe.img
						}
						
						// equipes[i].equipe_img = $rootScope.getEquipeImg(equipes[i].equipe_id);
					
					}
					else if (equipes[i].equipe_id_1 != undefined) {
						
						var equipe_1 = $rootScope.getEquipeByID(equipes[i].equipe_id_1);
						if (equipe_1 != undefined) {
							equipes[i].equipe_nome_1 = equipe_1.nome;
							equipes[i].equipe_sigla_1 = equipe_1.sigla;
							equipes[i].equipe_img_1 = equipe_1.img;
						}
						
						// equipes[i].equipe_img_1 = $rootScope.getEquipeImg(equipes[i].equipe_id_1);
						
						var equipe_2 = $rootScope.getEquipeByID(equipes[i].equipe_id_2);
						if (equipe_2 != undefined) {
							equipes[i].equipe_nome_2 = equipe_2.nome;
							equipes[i].equipe_sigla_2 = equipe_2.sigla;
							equipes[i].equipe_img_2 = equipe_2.img;
						}
						
						// equipes[i].equipe_img_2 = $rootScope.getEquipeImg(equipes[i].equipe_id_2);
					
					}
					
					// < Mercado
					if (equipes[i].d1 != undefined) {
						
						var equipe = $rootScope.getEquipeByID(equipes[i].d1);
						if (equipe != undefined) {
							equipes[i].d1_nome = equipe.nome;
							equipes[i].d1_sigla = equipe.sigla;
							equipes[i].d1_img = equipe.img;
						}
						
					}
					if (equipes[i].d2 != undefined) {
						
						var equipe = $rootScope.getEquipeByID(equipes[i].d2);
						if (equipe != undefined) {
							equipes[i].d2_nome = equipe.nome;
							equipes[i].d2_sigla = equipe.sigla;
							equipes[i].d2_img = equipe.img;
						}
						
					}
					if (equipes[i].d3 != undefined) {
						
						var equipe = $rootScope.getEquipeByID(equipes[i].d3);
						if (equipe != undefined) {
							equipes[i].d3_nome = equipe.nome;
							equipes[i].d3_sigla = equipe.sigla;
							equipes[i].d3_img = equipe.img;
						}
						
					}
					if (equipes[i].d4 != undefined) {
						
						var equipe = $rootScope.getEquipeByID(equipes[i].d4);
						if (equipe != undefined) {
							equipes[i].d4_nome = equipe.nome;
							equipes[i].d4_sigla = equipe.sigla;
							equipes[i].d4_img = equipe.img;
						}
						
					}
					if (equipes[i].d5 != undefined) {
						
						var equipe = $rootScope.getEquipeByID(equipes[i].d5);
						if (equipe != undefined) {
							equipes[i].d5_nome = equipe.nome;
							equipes[i].d5_sigla = equipe.sigla;
							equipes[i].d5_img = equipe.img;
						}
						
					}
					// > Mercado END
					
				}
				
			}
			
			if (equipes.time_1tr != undefined) {
				equipes.time_1tr = $rootScope.setEquipesDados(equipes.time_1tr);
			}
			if (equipes.time_2tr != undefined) {
				equipes.time_2tr = $rootScope.setEquipesDados(equipes.time_2tr);
			}
			if (equipes.time_pen != undefined) {
				equipes.time_pen = $rootScope.setEquipesDados(equipes.time_pen);
			}
			if (equipes.confrontos != undefined) {
				equipes.confrontos = $rootScope.setEquipesDados(equipes.confrontos);
			}
			
			return equipes;
			
		};
		// > Equipes END
		
		// < Init
		$rootScope.setConfiguracoes = function(configuracoes) {

			if (configuracoes.token != appConfig.token) {
				
				$ionicPopup.show({
					title: "Atualização disponível",
					subTitle: "Atualizar o aplicativo?",
					buttons: [
						{ 
							text: 'Agora não',
							onTap: function(e) {
								ionic.Platform.exitApp();
							}
						}, {
							text: 'Atualizar',
							type: 'button-dark',
							onTap: function(e) {
								window.open('market://details?id='+appConfig.id, '_system');
							}
						}
					]
				});
				
			}
			
			$rootScope.config = angular.extend({}, $rootScope.config, configuracoes);
			
			$rootScope.config['escudo_default'] = ($rootScope.config['escudo_default_'+ escudo +'_version'] == appConfig.version);
			$rootScope.config['device_id'] = (window.device) ? window.device.uuid : 1;
			$rootScope.config['horario_verao'] = ($rootScope.config['horario_verao'] === true || $rootScope.config['horario_verao'] === '1');
			
			setCache("configs_user", $rootScope.config);
			
		};
		$rootScope.setCampeonatos = function(campeonatos) {
			
			var cache = getCache("campeonatos_selecionados");
			if (cache != null) {
				$rootScope.campeonatos = cache;
				$rootScope.campeonatos_todos = getCache("campeonatos_todos");
				$rootScope.campeonatos_filtravel = $rootScope.campeonatos_todos;
			}

			// < Selecionados
			var newArray = [];
			var newArrayTodos = [];
			var keys = Object.keys(campeonatos);
			var keys_qtd = keys.length;
			for (var i=0;i < keys_qtd;i++) {
				
				var campeonato_id = keys[i];
				var campeonato = campeonatos[campeonato_id];
				
				if (campeonato != null) {
					if (campeonato['def_'+$rootScope.config['idioma']] != undefined) {
						campeonato.def = campeonato['def_'+$rootScope.config['idioma']];
					}
					if (
						(
							$rootScope.dados['ranking_tipo'] == 'cbr' 
							&& 
							campeonato.def == 'S'
						)||(
							$rootScope.dados['ranking_tipo'] != 'cbr'
							&&
							campeonato.campeonato_id == $rootScope.dados['ranking_tipo']
						)
					) {
						newArray.push(campeonato);
					}
					newArrayTodos.push(campeonato);
				}
				
			}
			campeonatos = newArray;
			campeonatos.sort(ordenarNome);
			
			var campeonatos_todos = newArrayTodos;
			campeonatos_todos.sort(ordenarNome);
			// > Selecionados END
			
			if (!cache) {
				$rootScope.campeonatos = campeonatos;
				setCache("campeonatos_selecionados", $rootScope.campeonatos);
			}
			
			$rootScope.campeonatos_todos = campeonatos_todos;
			$rootScope.campeonatos_filtravel = campeonatos_todos;
			setCache("campeonatos_todos", $rootScope.campeonatos_todos);
			
		};
		$rootScope.setEquipes = function(equipes) {
		
			$rootScope.equipes = equipes;
			equipes = $rootScope.setEquipesDados(equipes);
			$rootScope.equipes = equipes;

			$rootScope.equipes_br = [];
			var equipes_qtd = $rootScope.equipes.length;
			for (var i=0;i < equipes_qtd;i++) {
				if ($rootScope.equipes[i].br == 'S') {
					$rootScope.equipes_br.push($rootScope.equipes[i]);
				}
			}
			
			$rootScope.equipes_filtravel = $rootScope.equipes_br;
			
		};
		$rootScope.setDatas = function(datas) {
			$rootScope.data_atual = datas.geral.hoje;
			$rootScope.datas = datas;
		};
		$rootScope.setRodadas = function(rodadas, rodadas_limite) {
			$rootScope.rodadas = rodadas;
			$rootScope.rodadas_limite = rodadas_limite;
		};
		$rootScope.setFases = function(fases) {
		
			var keys = Object.keys(fases);
			var keys_qtd = keys.length;
			for (var i=0;i < keys_qtd;i++) {
			
				var campeonato = keys[i];
				
				$rootScope.fases[campeonato] = fases[campeonato]['fases'];
				$rootScope.fase[campeonato] = fases[campeonato]['atual'];
				$rootScope.titulo[campeonato] = fases[campeonato]['atual'];
			
			}
			
		};
		
		$rootScope.setInit = function(dados) {
			
			$rootScope.setConfiguracoes(dados.configuracoes);
			$rootScope.setCampeonatos(dados.campeonatos);
			$rootScope.setEquipes(dados.equipes);
			$rootScope.setDatas(dados.datas);
			$rootScope.setRodadas(dados.rodadas, dados.rodadas_limite);
			$rootScope.setFases(dados.fases);
			
			// $ionicLoading.hide();
			
		};
		$rootScope.init = function() {
			
			$ionicLoading.show();
			
			var cache = getCache("init");
			if (cache != null) {
				$rootScope.setInit(cache);
			}
			
			$rootScope.getDados('firebase/init', '/futebol/init', function(response) {
				
				$rootScope.setInit(response);
				setCache("init", response);
				
			});
			
		}();
		// > Init END
		
		// < Configurações
		$rootScope.setConfigsUser = function(configs) {

			var def = {
					token : appConfig.token,
					app_id : appConfig.id,
					version : appConfig.version,
					device_id : (window.device) ? window.device.uuid : 1,
					hoje : hoje
				};
				
			var params = angular.extend({}, def, configs);
			
			if (JSON.stringify(params) != JSON.stringify(getCache("configs_user_params"))) {
				
				$http({
					url: $rootScope.server_url+'usuarios/set',
					method: "POST",
					data: params,
					headers: {'Content-Type': 'application/x-www-form-urlencoded'}
				})
				.then(function(response) {
 					
					response = response.data;
					
					$rootScope.config = angular.extend({}, $rootScope.config, response);
					
					if (response.notification !== undefined) {
						$rootScope.config['notification'] = (response.notification === true || response.notification === "1");
					}
					if (response.news !== undefined) {
						$rootScope.config['news'] = (response.news === true || response.news === "1");
					}
					
					if ($rootScope.config['remove_ads']) {
						if (window.plugins) {
							if (window.plugins.AdMob) {
								window.plugins.AdMob.destroyBannerView();
							}
						}
					}
					
					setCache("configs_user", $rootScope.config);
					setCache("configs_user_params", params);
					
				});
				
			}
			
		};
		// > Configurações END

		// < Campeonatos
		$rootScope.getCampeonatoById = function(id) {
			
			if (id != undefined) {
				
				if ($rootScope.dados['getCampeonatoById'] == undefined) {
					$rootScope.dados['getCampeonatoById'] = {};
				}
				if ($rootScope.dados['getCampeonatoById'][id] != undefined) {
					return $rootScope.dados['getCampeonatoById'][id];
				}
				
				var campeonatos_qtd = $rootScope.campeonatos_todos.length;
				for (var i=0;i < campeonatos_qtd;i++) {
				
					var campeonato = $rootScope.campeonatos_todos[i];

					if (campeonato.campeonato_id == id) {
						$rootScope.dados['getCampeonatoById'][id] = campeonato;
						return campeonato;
					}

				}
				
			}
			
			return false;
			
		};
		$rootScope.getNomeCampeonatoBySigla = function(sigla, equipe) {
			
			if (sigla != undefined) {
				
				if (sigla == 'equipe') {
					
					if (equipe == undefined) {
						equipe = $rootScope.equipe;
					}
					
					if (equipe.nome == undefined) {
						return $rootScope.text['YOUR_TIME_GAMES'];
					}
					else {
						return $rootScope.text['GAMES_OF']+' '+equipe.nome;
					}
				}
				else if (sigla == 'data') {
					return $rootScope.text['GAMES_BY_DATE'];
				}
				else {
				
					var campeonatos_qtd = $rootScope.campeonatos_todos.length;
					for (var i=0;i < campeonatos_qtd;i++) {
					
						var campeonato = $rootScope.campeonatos_todos[i];
						
						if (campeonato.sigla == sigla) {
							if (campeonato['nome_'+$rootScope.config['idioma']] != undefined) {
								return campeonato['nome_'+$rootScope.config['idioma']];
							}
							else {
								return campeonato.nome;
							}
						}
						
					}
					
				}
				
			}
			
		};
		$rootScope.getIdCampeonatoBySigla = function(sigla) {
			
			if (sigla != undefined && $rootScope.campeonatos_todos != undefined) {
				
				if ($rootScope.dados['getIdCampeonatoBySigla'] == undefined) {
					$rootScope.dados['getIdCampeonatoBySigla'] = {};
				}
				if ($rootScope.dados['getIdCampeonatoBySigla'][sigla] != undefined) {
					return $rootScope.dados['getIdCampeonatoBySigla'][sigla];
				}
				
				var campeonatos_qtd = $rootScope.campeonatos_todos.length;
				for (var i=0;i < campeonatos_qtd;i++) {
				
					var campeonato = $rootScope.campeonatos_todos[i];
					
					if (campeonato.sigla == sigla) {
						$rootScope.dados['getIdCampeonatoBySigla'][sigla] = campeonato.campeonato_id;
						return campeonato.campeonato_id;
					}
					
				}
				
			}
			return false;
			
		};
		$rootScope.getNomeCampeonatoById = function(id) {
			
			if (id != undefined) {
				
				if ($rootScope.dados['getNomeCampeonatoById'] == undefined) {
					$rootScope.dados['getNomeCampeonatoById'] = {};
				}
				if ($rootScope.dados['getNomeCampeonatoById'][id] != undefined) {
					return $rootScope.dados['getNomeCampeonatoById'][id];
				}
				
				var campeonatos_qtd = $rootScope.campeonatos_todos.length;
				for (var i=0;i < campeonatos_qtd;i++) {
				
					var campeonato = $rootScope.campeonatos_todos[i];
					
					if (campeonato.campeonato_id == id) {
						if (campeonato['nome_'+$rootScope.config['idioma']] != undefined) {
							var nome = campeonato['nome_'+$rootScope.config['idioma']];
						}
						else {
							var nome = campeonato.nome;
						}
						$rootScope.dados['getNomeCampeonatoById'][id] = nome;
						return nome;
					}
					
				}
				
			}
			
		};
		$rootScope.getIdsCampeonatosSelecionados = function() {
			
			var ids = '';
			
			var campeonatos = getCache("campeonatos_selecionados");
			if (campeonatos) {
					
				var campeonatos_qtd = campeonatos.length;
				for (var i=0;i < campeonatos_qtd;i++) {
					
					var campeonato = campeonatos[i];
					if (ids != '') {
						ids += ',';
					}
					ids += campeonato.campeonato_id;
						
				}
				
			}
			return ids;
			
		};
		
		$rootScope.chkCampAttrBySigla = function(attr, sigla) {
			
			var campeonato_id = $rootScope.getIdCampeonatoBySigla(sigla);
			if (campeonato_id) {
				var campeonato = $rootScope.getCampeonatoById(campeonato_id);
				return (campeonato[attr] == 'S');
			}
			else {
				return false;
			}
			
		};
		// > Campeonatos END
		
		$rootScope.getDataISO = function(jogo) {
			
			var e = jogo.data_jogo.split(' ');
			e = e[1].split('/');
			
			var dia = e[0];
			var mes = e[1];
			var ano = e[2];
			
			e = jogo.hora_jogo.split(':');
			var hora = e[0];
			if (hora == '--') {
				hora = '00';
			}
			var minuto = e[1].replace('h','');
			if (minuto == '--') {
				minuto = '00';
			}
			
			return ano +'-'+ mes +'-'+ dia +'T'+ hora +':'+ minuto +':00-03:00';
			
		};
		
		$rootScope.showInterstitial = function() {
			
			if (!($rootScope.config['remove_ads'])) {
				
				if (window.plugins) {
					if (window.plugins.AdMob) {
						window.plugins.AdMob.createInterstitialView();
						window.plugins.AdMob.showInterstitialAd(
							true, 
							function(){},
							function(e){
								// alert(JSON.stringify(e));
							}
						);
					}
				}
				
			}
			
		};
		
		$rootScope.initNotification = function() {
			
			var config = getCache("configs_user", true);
				var notification = config['notification'] ? '1' : '0';
				var news = config['news'] ? '1' : '0';
				var sound = config['sound'];
				var idioma = config['idioma'];

			var campeonatos = $rootScope.getIdsCampeonatosSelecionados();
		
			if (window.PushNotification) {
				
				var push = PushNotification.init({
					"android": {
						"senderID": "212487105854",
						"sound": sound,
						"icon" : "icon",
						"forceShow" : true, // mesmo com o app aberto
						"iconColor" : "#47A721"
						// "clearNotifications" : false,
						// "topics" : "['all']"
						// "clearBadge" : true
					},
					"ios": {
						"sound": sound,
						"alert": true,
						"badge": true
						// "topics" : "['all']"
						// "clearBadge" : true
					},
					"windows": {}
				});
				
				PushNotification.hasPermission(function(permissionResult) {
					if (permissionResult.isEnabled) {
						
						push.on('registration', function(data) {
							$rootScope.setConfigsUser({ 
									push_id : data.registrationId,
									notification : notification,
									news : news,
									language : idioma,
									campeonatos : campeonatos
								});
						});
						
						push.on('notification', function(data) {
							
							if (data.additionalData.noticia_link != undefined) {
								if ($rootScope.noticia == undefined) {
									$rootScope.noticia = {};
								}
								$rootScope.noticia.link = data.additionalData.noticia_link;
								$state.go('app.noticias');
								setTimeout(function() {
									$state.go('app.noticia');
								}, 1000);
							}
							else if (data.additionalData.jogo_id != undefined) {
								$rootScope.dados['load_jogo'] = data.additionalData.jogo_id;
								$state.go('app.jogo-ficha', { jogo_id : data.additionalData.jogo_id });
							}
							else if (data.additionalData.go != undefined) {
								$state.go(data.additionalData.go);
							}
							else if (data.additionalData.update != undefined) {
								window.open('market://details?id='+appConfig.id, '_system');
							}
							
						});
						
					}
				});
				
			}
			else {
				$rootScope.setConfigsUser({ 
						push_id : 2,
						notification : notification,
						news : news,
						language : idioma,
						campeonatos : campeonatos
					});
			}

		};
		$rootScope.initNotification();
		$rootScope.toast = function(msg) {
			if (window.plugins) {
				window.plugins.toast.showShortCenter(
					msg, function(a){}, function(b){}
				);
			}
			else {
				alert(msg);
			}
		};
		
		$rootScope.checkConnection = function(hidden) {
		
			if (window.Connection) {
				if (navigator.connection.type == Connection.NONE) {
							
					$ionicLoading.hide()
					
					if (!hidden) {
						
						$ionicPopup.alert({
							title: $rootScope.text['NOT_CONNECTED'],
							okType : 'button-dark'
						})
						.then(function() {
							if (getCache('init') == null) {
								ionic.Platform.exitApp();
							}
						});
						
					}
					
					return false;
					
				}
				else
					return true;
			}
			else
				return true;
			
		};
		$rootScope.checkConnection(false);

		// < Premium
		$rootScope.loadProducts = function() {
			
			if (window.plugins) {
				
				$ionicLoading.show();
				inAppPurchase
					.getProducts(['1_mes','3_meses','6_meses','1_ano','1_ano_'])
					.then(function(products) {
						$ionicLoading.hide();
						$rootScope.products = products;
						// alert(JSON.stringify(products));
					})
					.catch(function(err) {
						$ionicLoading.hide();
						// alert(JSON.stringify(err));
					});
				
			}
			else {
				
				$rootScope.products = [
					{ productId: '1_mes', 'title': '1 mês sem anúncios (Brasileirão 2018 Série A BCD)', description: '1 mês', price: 'R$ 1,99' },
					{ productId: '3_meses', 'title': '3 meses sem anúncios (Brasileirão 2018 Série A BCD)', description: '3 meses', price: 'R$ 3,90' },
					{ productId: '6_meses', 'title': '6 meses sem anúncios (Brasileirão 2018 Série A BCD)', description: '6 meses', price: 'R$ 6,90' },
					{ productId: '1_ano_', 'title': '1 ano sem anúncios (Brasileirão 2018 Série A BCD)', description: '1 ano', price: 'R$ 9,90' }
				];
				
			}
		
		};
		$rootScope.buy = function(productId) {

			if (window.plugins) {
			
				$ionicLoading.show();
				inAppPurchase
					.buy(productId)
					.then(function(data) {
						// alert(JSON.stringify(data));
						// alert('consuming transactionId: ' + data.transactionId);
						transaction = data;
						return inAppPurchase.consume(data.type, data.receipt, data.signature);
					})
					.then(function() {
						
						// $ionicPopup.alert({
							// title: 'Compra efetuada com sucesso!',
							// template: 'Agora você é Premium'
						// });
	
						$rootScope.setConfigsUser({ 
								pid : productId,
								authorization : getAuthorization($rootScope.config['device_id'] + productId + appConfig.id),
								receipt : base64Encode(JSON.stringify(transaction.receipt))
							}, true);
						
						$ionicLoading.hide();
						
						$state.reload();
						
					})
					.catch(function(err) {
						$ionicLoading.hide();
						// alert(JSON.stringify(err));
						// $ionicPopup.alert({
							// title: 'Something went wrong',
							// template: 'Check your console log for the error details'
						// });
					});
					
			}
			else {
				
				$rootScope.setConfigsUser({ 
						pid : productId,
						authorization : getAuthorization($rootScope.config['device_id'] + productId + appConfig.id),
						receipt : base64Encode(JSON.stringify({ 'purchaseToken' : 'xxx' }))
					}, true);
				
				$state.reload();
				
			}

		};
		$rootScope.restoreBuy = function(productId) {

			if (window.plugins) {
			
				$ionicLoading.show();
				inAppPurchase
				  .restorePurchases()
				  .then(function (data) {
						// console.log(data);
						alert(JSON.stringify(data));
					/*
					  [{
						transactionId: ...
						productId: ...
						state: ...
						date: ...
					  }]
					*/
						$ionicLoading.hide();
				  })
				  .catch(function (err) {
						// console.log(err);
						alert(JSON.stringify(err));
						$ionicLoading.hide();
				  });
				
			}

		};
		// > Premium END
		
	});
	
	$ionicPlatform.registerBackButtonAction(function(e) {
		
		// var current = $state.current.name;
		
		if ($ionicHistory.backView()) {
			$ionicHistory.goBack();
		}
		// else if (current != 'app.jogos') {
			// $ionicHistory.clearHistory();
			// $state.go('app.jogos');
		// }
		else if ($rootScope.backButtonPressedOnceToExit) {
			ionic.Platform.exitApp();
		}
		else {
			$rootScope.backButtonPressedOnceToExit = true;
			$rootScope.toast($rootScope.text['TAP_AGAIN_EXIT']);
			setTimeout(function() {
				$rootScope.backButtonPressedOnceToExit = false;
			}, 2000);
		}
		e.preventDefault();
		return false;
		
	}, 101);

	$ionicPlatform.on('pause', function () {
		app_in_background = true;
	});
	
	$ionicPlatform.on('resume', function () {
		app_in_background = false;
	});
	
})

.config(function($stateProvider, $urlRouterProvider) {
  
$stateProvider

	.state('app', {
		url: '/app',
		abstract: true,
		controller: 'AppCtrl',
		templateUrl: 'templates/main.html'
	})
	
	.state('app.selecionar-time', {
		url: '/selecionar-time',
		views: {
			'mainContent': {
				templateUrl: 'templates/selecionar_time.html'
			}
		}
	})
	
	.state('app.selecionar-campeonatos', {
		url: '/selecionar-campeonatos',
		views: {
			'mainContent': {
				templateUrl: 'templates/selecionar_campeonatos.html'
			}
		}
	})
	.state('app.selecionar-campeonatos-estaduais', {
		url: '/selecionar-campeonatos-estaduais',
		views: {
			'mainContent': {
				templateUrl: 'templates/selecionar_campeonatos_estaduais.html'
			}
		}
	})
	
	.state('app.noticias', {
		url: '/noticias',
		views: {
			'mainContent': {
				templateUrl: 'templates/noticias.html'
			}
		}
	})
	.state('app.noticia', {
		url: '/noticia',
		views: {
			'mainContent': {
				templateUrl: 'templates/noticia.html'
			}
		}
	})
	.state('app.mercado', {
		url: '/mercado',
		views: {
			'mainContent': {
				templateUrl: 'templates/mercado.html'
			}
		}
	})
	
	.state('app.jogos', {
		url: '/jogos',
		views: {
			'mainContent': {
				templateUrl: 'templates/jogos.html'
			},
			'menuContent': {
				templateUrl: 'templates/menu.html'
			}
		}
	})
	.state('app.artilheiros', {
		url: '/artilheiros',
		views: {
			'mainContent': {
				templateUrl: 'templates/artilheiros.html'
			}
		}
	})
	.state('app.assistencias', {
		url: '/assistencias',
		views: {
			'mainContent': {
				templateUrl: 'templates/assistencias.html'
			}
		}
	})
	.state('app.classificacao', {
		url: '/classificacao',
		views: {
			'mainContent': {
				templateUrl: 'templates/classificacao.html'
			}
		}
	})
	
	.state('app.jogo-ficha', {
		url: '/jogos-ficha/:jogo_id',
		views: {
			'mainContent': {
				templateUrl: 'templates/jogo.html'
			}
		}
	})
	.state('app.jogo-numeros', {
		url: '/jogos-numeros/:jogo_id',
		views: {
			'mainContent': {
				templateUrl: 'templates/jogo.html'
			}
		}
	})
	.state('app.jogo-time', {
		url: '/jogos-time/:jogo_id',
		views: {
			'mainContent': {
				templateUrl: 'templates/jogo.html'
			}
		}
	})
	.state('app.jogo-confrontos', {
		url: '/jogos-confrontos/:jogo_id',
		views: {
			'mainContent': {
				templateUrl: 'templates/jogo.html'
			}
		}
	})
  
	.state('app.premium', {
		url: '/premium',
		views: {
			'mainContent': {
				templateUrl: 'templates/premium.html'
			}
		}
	})
	.state('app.ranking-torcedores', {
		url: '/ranking/torcedores',
		views: {
			'mainContent': {
				templateUrl: 'templates/ranking_torcedores.html'
			}
		}
	})
	.state('app.configuracoes', {
		url: '/configuracoes',
		views: {
			'mainContent': {
				templateUrl: 'templates/configuracoes.html'
			}
		}
	})

	$urlRouterProvider.otherwise('/app/jogos');
  
});