function setCache( key, valor ) {
	
	if (valor == undefined) {
		valor = null;
	}
	localStorage.setItem(key, JSON.stringify(valor));
	
}

function getCache( key, retornaObj, def ) {
	
	if (localStorage.getItem(key) !== null && localStorage.getItem(key) != 'undefined') {
		return JSON.parse(localStorage.getItem(key));
	}
	else if (retornaObj === true) {
		return {};
	}
	else if (def != undefined) {
		return def;
	}
	else {
		return null;
	}
	
}

function getCacheKeys( filtrar ) {
	
	var newArray = [];
	var qtd = localStorage.length;
	for (var i = 0;i < qtd;i++) {
		
		var key = localStorage.key(i);
		if (filtrar == undefined || key.indexOf(filtrar) >= 0) {
			newArray.push(key);
		}
	  
	}
	return newArray;
	
}

function remCache( key, filtrar ) {
	
	if (filtrar != undefined) {
		
		var keys = getCacheKeys( filtrar );
		var qtd = keys.length;
		for (var i = 0;i < qtd;i++) {
			key = keys[i];
			localStorage.removeItem(key);
		}
		
	}
	else {
		localStorage.removeItem(key);
	}
	
}

function imageJogoBase64( jogo ) {
	
	var canvas = document.createElement('canvas');
		canvas.width  = 500;
		canvas.height = 300;
		// document.body.appendChild(canvas);
    var context = canvas.getContext("2d");
		context.fillStyle = "white";
		context.fillRect(0, 0, canvas.width, canvas.height);	
		context.fillStyle = 'black';
	
	var width  = 51;
	var height = 51;

	context.font = "30px impact";
	var frase = jogo.campeonato;
	context.textAlign = 'center';
	context.fillText(frase, canvas.width/2, canvas.height*0.2);
	
	context.font = "100px impact";
	var frase = jogo.gols_1+' x '+jogo.gols_2;
	context.textAlign = 'center';
	context.fillText(frase, canvas.width/2, canvas.height*0.55);
	
	context.font = "20px calibri";
	frase = jogo.hora_jogo+' '+jogo.data_jogo;
	context.fillText(frase, canvas.width/2, canvas.height*0.65);
	
	context.font = "20px impact";
	frase = jogo.equipe_nome_1;
	context.textAlign = 'left';
	context.fillText(frase, 20, canvas.height*0.55);
	
	context.font = "20px impact";
	frase = jogo.equipe_nome_2;
	context.textAlign = 'right';
	context.fillText(frase, canvas.width-20, canvas.height*0.55);
	
	var img1 = document.getElementById('img1');
	img1.onload = function() {
		context.drawImage(img1, 20, canvas.height*0.26);
	}; 
	img1.src = "http://licoski.com/futebol-server/public/img/51/"+jogo.equipe_id_1+".png"
	
	var img2 = document.getElementById('img2');
	img2.onload = function() {
		context.drawImage(img2, canvas.width-width-20, canvas.height*0.26);
	}; 
	img2.src = "http://licoski.com/futebol-server/public/img/51/"+jogo.equipe_id_2+".png"
		
	return canvas.toDataURL();
	
}

function removerAcentos( string ) {
	
	var mapaAcentosHex 	= {
		a : /[\xE0-\xE6]/g,
		e : /[\xE8-\xEB]/g,
		i : /[\xEC-\xEF]/g,
		o : /[\xF2-\xF6]/g,
		u : /[\xF9-\xFC]/g,
		c : /\xE7/g,
		n : /\xF1/g
	};

	for ( var letra in mapaAcentosHex ) {
		var expressaoRegular = mapaAcentosHex[letra];
		string = string.replace( expressaoRegular, letra );
	}

	return string;
	
}

function ordenar( a, b ) {
	
	if (parseInt(a.ordem) < parseInt(b.ordem))
		return -1;
	if (parseInt(a.ordem) > parseInt(b.ordem))
		return 1;
	return 0;
	
}

function ordenarNome( a, b ) {
	if (a.nome < b.nome)
		return -1;
	if (a.nome > b.nome)
		return 1;
	return 0;
}

function ordenarBy( dados, criterios ) {
	
	var keysDados = Object.keys(dados);
	var keysCriterios = Object.keys(criterios);
	
	var arrayLength = [];
	for (var i=0;i < keysDados.length;i++) {
		
		var keyD = keysDados[i];
		var dado = dados[keyD];
		
		for (var j=0;j < keysCriterios.length;j++) {
			
			var keyC = keysCriterios[j];
			var criterio = criterios[keyC];
			
			if (dado[keyC] != undefined) {
				
				var size = dado[keyC].length;
				
				if (arrayLength[keyC] == undefined) {
					arrayLength[keyC] = 0;
				}
				if (size > arrayLength[keyC]) {
					arrayLength[keyC] = size;
				}
				
			}
			
		}
		
	}
	
	var newArray = [];
	for (var i=0;i < keysDados.length;i++) {
		
		var keyD = keysDados[i];
		var dado = dados[keyD];
		
		for (var j=0;j < keysCriterios.length;j++) {
			
			var keyC = keysCriterios[j];
			var criterio = criterios[keyC];
			
			if (dado[keyC] != undefined) {
				
				if (dado.ordem == undefined) {
					dado.ordem = '';
				}
				
				var size = dado[keyC].length;
				
				if (criterio == 'string') {
					aux = ((' ').repeat((parseInt(arrayLength[keyC])-parseInt(size))));
					dado.ordem += dado[keyC] + aux;
				}
				else if (criterio == 'number') {
					
					var n = parseInt(somenteNumeros(dado[keyC]));
					if (isNaN(n)) {
						n = 0;
					}
					
					aux = ((' ').repeat((parseInt(arrayLength[keyC])-parseInt((n+'').length))));
					dado.ordem += aux + n;
					
				}
				else if (criterio == 'date') {
					
					var e = dado[keyC].split(' ');
					var e = e[1].split('/');
						var dia = e[0];
						var mes = e[1];
						var ano = e[2];
						
					dado.ordem += ano+mes+dia;
					
				}
				else if (criterio == 'time') {
					
					var e = dado[keyC].split(':');
						var hora = e[0];
						var minuto = e[1];
						
					dado.ordem += hora+somenteNumeros(minuto);
					
				}
				
			}
			
		}
		
		newArray.push(dado);
		
	}
	
	dados = newArray;
	dados.sort(ordenarString);
	
	return dados;
	
}

function ordenarString( a, b ) {
	
	if (a.ordem < b.ordem)
		return -1;
	if (a.ordem > b.ordem)
		return 1;
	return 0;
	
}

function getStatsPerc( v1, v2, isNull100 ) {
	
	var total = (parseInt(v1) + parseInt(v2));
	
	if (!parseInt(total) && isNull100 === true) {
		return '100%';
	}
	else if (!parseInt(v1)) {
		return '0%';
	}
	
	return ((v1 / total) * 100).toFixed(2)+'%';
	
}

function dayOfWeek(str, language) {
	
	if (language == 'pt') {
		return str.replace('Monday', 'SEG')
			.replace('Tuesday', 'TER')
			.replace('Wednesday', 'QUA')
			.replace('Thursday', 'QUI')
			.replace('Friday', 'SEX')
			.replace('Saturday', 'SÁB')
			.replace('Sunday', 'DOM');
	}
	else if (language == 'es') {
		return str.replace('Monday', 'LUN')
			.replace('Tuesday', 'MAR')
			.replace('Wednesday', 'MIÉ')
			.replace('Thursday', 'JUE')
			.replace('Friday', 'VIE')
			.replace('Saturday', 'SÁB')
			.replace('Sunday', 'DOM');
	}
	else {
		var day = str.substr(0,3).toUpperCase();
		return str.replace('Monday', day)
			.replace('Tuesday', day)
			.replace('Wednesday', day)
			.replace('Thursday', day)
			.replace('Friday', day)
			.replace('Saturday', day)
			.replace('Sunday', day);
	}
	
}

function somenteNumeros(str) {
	
	return (str == undefined) ? undefined : str.replace(/\D+/g, "");
	
}

function getAuthorization( str ) {
	
	str = base64Encode(str);
	if (str.length > 5) {
		str = str.substr(str.length-5, 5);
	}
	str = reverse(str);
	
	return str;
	
}

function base64Encode( str ) {
	
	var Base64={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){var t="";var n,r,i,s,o,u,a;var f=0;e=Base64._utf8_encode(e);while(f<e.length){n=e.charCodeAt(f++);r=e.charCodeAt(f++);i=e.charCodeAt(f++);s=n>>2;o=(n&3)<<4|r>>4;u=(r&15)<<2|i>>6;a=i&63;if(isNaN(r)){u=a=64}else if(isNaN(i)){a=64}t=t+this._keyStr.charAt(s)+this._keyStr.charAt(o)+this._keyStr.charAt(u)+this._keyStr.charAt(a)}return t},decode:function(e){var t="";var n,r,i;var s,o,u,a;var f=0;e=e.replace(/[^A-Za-z0-9+/=]/g,"");while(f<e.length){s=this._keyStr.indexOf(e.charAt(f++));o=this._keyStr.indexOf(e.charAt(f++));u=this._keyStr.indexOf(e.charAt(f++));a=this._keyStr.indexOf(e.charAt(f++));n=s<<2|o>>4;r=(o&15)<<4|u>>2;i=(u&3)<<6|a;t=t+String.fromCharCode(n);if(u!=64){t=t+String.fromCharCode(r)}if(a!=64){t=t+String.fromCharCode(i)}}t=Base64._utf8_decode(t);return t},_utf8_encode:function(e){e=e.replace(/rn/g,"n");var t="";for(var n=0;n<e.length;n++){var r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r)}else if(r>127&&r<2048){t+=String.fromCharCode(r>>6|192);t+=String.fromCharCode(r&63|128)}else{t+=String.fromCharCode(r>>12|224);t+=String.fromCharCode(r>>6&63|128);t+=String.fromCharCode(r&63|128)}}return t},_utf8_decode:function(e){var t="";var n=0;var r=c1=c2=0;while(n<e.length){r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r);n++}else if(r>191&&r<224){c2=e.charCodeAt(n+1);t+=String.fromCharCode((r&31)<<6|c2&63);n+=2}else{c2=e.charCodeAt(n+1);c3=e.charCodeAt(n+2);t+=String.fromCharCode((r&15)<<12|(c2&63)<<6|c3&63);n+=3}}return t}}
	return Base64.encode(str);
	
}

function reverse( str ) {
	
    return str.split("").reverse().join("");
	
}
